<template>
  <div
      class="min-h-full flex items-center justify-center py-6 px-4 sm:px-6 lg:px-8"
  >
    <div class="max-w-lg w-full bg-white p-4 md:px-8 md:py-10 shadow-xl z-10">
      <div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          Créer mon road-trip
        </h2>
      </div>
      <Vuemik
          :initial-values="roadtrip.AToB.formValues"
          v-slot="{ values, handleSubmit }"
          :submitWithEnter="false"
          :on-submit="roadtrip.submitAToB"
          :violations="roadtrip.AToB.violations"
      >
        <Field
            label="Nom (optionnel) :"
            component="input"
            type="text"
            name="name"
            @input="roadtrip.setNameUpdated()"
        />
        <div class="mt-5">
          <div class="flex flex-row h-10">
            <div
                :class="
                'w-1/2 text-center align-middle text-lg uppercase font-bold cursor-pointer hover:bg-gray-100 p-2 '
                  +(choiceMode === 'city' ? ' bg-gray-200' : '')"
                @click="choiceMode = 'city'"
            >
              Par ville
            </div>
            <div
                :class="
                'w-1/2 text-center align-middle text-lg uppercase font-bold cursor-pointer hover:bg-gray-100 p-2'
                  +(choiceMode === 'map' ? ' bg-gray-200' : '')"
                @click="choiceMode = 'map'; mapChosen = true;"
            >
              Par carte
            </div>
          </div>
          <div v-show="choiceMode === 'city'">
            <CityChoose
                label="Point de départ"
                name="cityA"
                placeholder="Paris, Marseille, Lyon..."
                :reset="() => roadtrip.resetCityPoints('A', values)"
                :onSelectCity="city => roadtrip.selectCity(city,values,'A')"
            />
            <CityChoose
                label="Point d'arrivée"
                name="cityB"
                placeholder="Bordeaux, Nice, Strasbourg..."
                :reset="() => roadtrip.resetCityPoints('B', values)"
                :onSelectCity="city => roadtrip.selectCity(city,values,'B')"
            />
          </div>
          <div v-if="mapChosen" v-show="choiceMode === 'map'">
            <MapChoosePoints/>
          </div>
        </div>
        <Field
            label="Nombre de jours :"
            component="input"
            type="number"
            name="nbDays"
            min="1"
        />
        <Field
            label="Temps minimum par étape :"
            component="input"
            type="time"
            name="minimumDurationByStep"
        />
        <NbStepsByDay/>
        <tags-categories-preferences-provider
            :field="values.interests"
            type="POI"
        />
        <tags-categories-preferences-provider
            :field="values.interestsRestaurant"
            type="restaurant"
        />
        <tags-categories-preferences-provider
            :field="values.categoriesHostel"
            type="hostel"
        />

        <Field
            component="input"
            type="button"
            value="Rechercher mon trajet"
            @click="handleSubmit"
        />
      </Vuemik>
    </div>
  </div>
</template>
<script>
import TagsCategoriesPreferencesProvider from "@/providers/TagsCategoriesPreferencesProvider";
import NbStepsByDay from "@/components/Form/NbStepsByDay";
import CityChoose from "@/components/Form/CityChoose";
import MapChoosePoints from "@/components/Form/MapChoosePoints";

export default {
  name: "AtoBForm",
  inject: ["roadtrip"],
  data: () => ({
    choiceMode: "city", // 'city' or 'map'
    mapChosen: false
  }),
  components: {
    MapChoosePoints,
    CityChoose,
    NbStepsByDay,
    TagsCategoriesPreferencesProvider,
  },
  mounted() {
    this.roadtrip.reset()
  }
};
</script>
